﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;

namespace WojciechFialkiewicz.Utils
{
    public class FilesReader
    {
        const string ResultsDir = "C:\\inetpub_logs\\results\\";

        private static List<string> ReturnFileNames()
        {
            DirectoryInfo di = new DirectoryInfo(ResultsDir);
            List<String> files = new List<string>();

            foreach (FileInfo fi in di.EnumerateFiles())
            {
                files.Add(fi.Name);
            }

            return files;
        }

        private static string GetValue(string line)
        {
            string[] arr = line.Split(':');

            return arr[1].Trim();
        }

        private static FileWithNumbers GetAllAndUnique(string name)
        {
            try
            {
                StreamReader reader = new StreamReader(ResultsDir + name);
                string line = reader.ReadLine();
                string previousLine = null;
                string previouspreviousline = null;
                FileWithNumbers fwn = new FileWithNumbers();

                do
                {
                    previouspreviousline = previousLine;
                    previousLine = line;
                } while ((line = reader.ReadLine()) != null);

                fwn.Name = name.Substring(0, name.Length - 5);
                fwn.AllVisits = GetValue(previouspreviousline);
                fwn.UniqueVisitors = GetValue(previousLine);

                return fwn;
            }
            catch (Exception)
            {
                return null;
            }
        }

        public static List<FileWithNumbers> GetFilesWithNumbers()
        {
            try
            {
                List<FileWithNumbers> files = new List<FileWithNumbers>();
                List<string> names = ReturnFileNames();

                foreach (string str in names)
                {
                    FileWithNumbers fwn = GetAllAndUnique(str);

                    if (fwn != null)
                    {
                        files.Add(GetAllAndUnique(str));
                    }
                }
                return files;
            }
            catch (Exception)
            {
                return null;
            }
        }
    }
}